# CodeMirror 6 language package for BlockScholes query language

This repo defines a [CodeMirror](https://codemirror.net/6/) language support package for the BlockScholes query language. The query language is used in the UI's historical analyzer. This package tells CodeMirror how to parse the language.

The current implementation only supports function application on strings:

```
avg("CB.BTC.USD", sum("CB.ETH.EUR"))
```

## TODO

- [ ] support numbers
- [ ] support arithmetic

## Making changes

1. Amend the grammar in src/syntax.grammar. See the [Lezer system guide](https://lezer.codemirror.net/docs/guide/#writing-a-grammar) for information on this file format.

1. Adjust the metadata in `src/index.ts` to work with your new grammar.

1. Adjust the grammar tests in `test/cases.txt`.

1. Build (`yarn run prepare`) and test (`yarn test`).

1. Run `yarn run build:grammar` to create values for the parser terms.

1. Publish with `yarn publish --access=public`. You will need to be in the Blockscholes organization on npm.
