import { LRParser } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Identifier = {__proto__:null,avg:71, cdf:73, log10:75, corr:77, hist:79, max:81, mean:83, min:85, ln:89, regress:91, shift:93, sqrt:95, stdev:97, rstdev:99, sum:101};
const parser = LRParser.deserialize({
  version: 13,
  states: "'OOVQPOOOOQO'#Cj'#CjOOQO'#Ca'#CaO!gQPO'#C`OOQO'#Cs'#CsQ!lQPOOOOQO'#Cz'#CzOVQPO'#CyOOQO'#C^'#C^OOQO'#Cb'#CbOOQO'#Cc'#CcOOQO'#Cd'#CdOOQO'#Ce'#CeOOQO'#Cf'#CfOOQO'#Cg'#CgOOQO'#Ch'#ChOOQO'#Ci'#CiOOQO'#Ck'#CkOOQO'#Cl'#ClOOQO'#Cm'#CmOOQO'#Cn'#CnOOQO'#Co'#CoOOQO'#Cp'#CpOOQO'#Cq'#CqO!}QPO'#CrOOQO,58z,58zOOQO'#Cu'#CuOOQO'#Cv'#CvOOQO'#Cw'#CwOOQO'#Cx'#CxOVQPO,59`OVQPO,59`OVQPO,59`OVQPO,59`O#UQPO,59eO#pQPO'#DcO#zQPO,59^O$hQPO1G.zO%WQPO1G.zO%_QPO1G.zO%fQPO1G.zOVQPO'#C{O%mQPO,59}OOQO1G.x1G.xO%uQPO,59gOOQO-E6y-E6y",
  stateData: "&P~OrOS~ORWOsXOtYOuZOv[Ow]Ox^Oy_Oz`O{PO|aO}bO!OcO!PdO!QeO!RfO!SgO!XSO!ZUO![UO~O!UhO~O{PO!YjO!ZkO![lO!]mO~O!T!VP~PVO!YjOpma{ma!Zma![ma!]ma!Tma!Wma~O!WyO!T!VX~P!lO!T{O~O!YjOphi!Zhi![hi!]hi!Thi!Whi~O{hi~P$PO{PO!YjO!]mOphi![hi!Thi!Whi~O!Zhi~P$oO!ZkO~P$oO{PO~P$PO!WyO!T!Va~O!Toa!Woa~P!lO",
  goto: "$w!WPP!XP!q!{#V#V#V#V#V#V#V#V#a#V#V#V#V#V#V#V#s!q!q#v$Q$W$]!q$d$nPPPPPPPPPPPPPPPPPPPPP$tQTOQrVQshQunQvoQwpQxqR|yaWOVhnopqyaROVhnopqyaQOVhnopqy`QOVhnopqy]nTsvwx|RiRanTrsuvwx|XoTsw|VpTs|ZqTsvw|aVOVhnopqyQzsR}zRth",
  nodeNames: "⚠ BSLang Expr Identifier FunctionCall FunctionIdentifier Average Cdf CommonLog Correlation Histogram Maximum Mean Minimum Mul NaturalLog Regression Shift Sqrt Stdev R_Stdev Sum FunctionCallBody NumberLiteral BinaryExpression Pow Add Sub Div UnaryExpression UnaryOp",
  maxTerm: 59,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "%f~R`XY!TYZ!T]^!Tpq!Txy!fyz!kz{!p{|!u|}!z}!O#P!O!P#U!P!Q$U!Q![$Z!c!}$l#Q#R%a#T#o$l~!YSr~XY!TYZ!T]^!Tpq!T~!kO!U~~!pO!T~~!uO{~~!zO!Z~~#PO!W~~#UO![~~#XP!Q![#[~#aR!X~!Q![#[!g!h#j#X#Y#j~#mR{|#v}!O#v!Q![#|~#yP!Q![#|~$RP!X~!Q![#|~$ZO!]~~$`S!X~!O!P#[!Q![$Z!g!h#j#X#Y#j~$qTR~}!O$l!O!P%Q!Q![$l!c!}$l#T#o$l~%TS}!O$l!Q![$l!c!}$l#T#o$l~%fO!Y~",
  tokenizers: [0],
  topRules: {"BSLang":[0,1]},
  specialized: [{term: 3, get: value => spec_Identifier[value] || -1}],
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = (sources) => {
    return BSLanguage.data.of({
        autocomplete: completeFromList([
            { label: "avg", type: "function" },
            { label: "cdf", type: "function" },
            { label: "log10", type: "function" },
            { label: "corr", type: "function" },
            { label: "hist", type: "function" },
            { label: "max", type: "function" },
            { label: "mean", type: "function" },
            { label: "min", type: "function" },
            { label: "ln", type: "function" },
            { label: "regress", type: "function" },
            { label: "shift", type: "function" },
            { label: "sqrt", type: "function" },
            { label: "stdev", type: "function" },
            { label: "sum", type: "function" },
        ].concat(sources))
    });
};
function BSLANG(autocompletionSources = []) {
    return new LanguageSupport(BSLanguage, [bslangCompletion(autocompletionSources)]);
}

// This file was generated by lezer-generator. You probably shouldn't edit it.
const
  BSLang = 1,
  Expr = 2,
  Identifier = 3,
  FunctionCall = 4,
  FunctionIdentifier = 5,
  Average = 6,
  Cdf = 7,
  CommonLog = 8,
  Correlation = 9,
  Histogram = 10,
  Maximum = 11,
  Mean = 12,
  Minimum = 13,
  Mul = 14,
  NaturalLog = 15,
  Regression = 16,
  Shift = 17,
  Sqrt = 18,
  Stdev = 19,
  R_Stdev = 20,
  Sum = 21,
  FunctionCallBody = 22,
  NumberLiteral = 23,
  BinaryExpression = 24,
  Pow = 25,
  Add = 26,
  Sub = 27,
  Div = 28,
  UnaryExpression = 29,
  UnaryOp = 30;

var parser_terms = /*#__PURE__*/Object.freeze({
  __proto__: null,
  BSLang: BSLang,
  Expr: Expr,
  Identifier: Identifier,
  FunctionCall: FunctionCall,
  FunctionIdentifier: FunctionIdentifier,
  Average: Average,
  Cdf: Cdf,
  CommonLog: CommonLog,
  Correlation: Correlation,
  Histogram: Histogram,
  Maximum: Maximum,
  Mean: Mean,
  Minimum: Minimum,
  Mul: Mul,
  NaturalLog: NaturalLog,
  Regression: Regression,
  Shift: Shift,
  Sqrt: Sqrt,
  Stdev: Stdev,
  R_Stdev: R_Stdev,
  Sum: Sum,
  FunctionCallBody: FunctionCallBody,
  NumberLiteral: NumberLiteral,
  BinaryExpression: BinaryExpression,
  Pow: Pow,
  Add: Add,
  Sub: Sub,
  Div: Div,
  UnaryExpression: UnaryExpression,
  UnaryOp: UnaryOp
});

export { BSLANG, BSLanguage, parser_terms as Terms, bslangCompletion };
